/*
Daybo Logic Run-Time TarBall Library And Tools
Copyright (c) 2000-2006, David Duncan Ross Palmer, Daybo Logic
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
      
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
      
    * Neither the name of the Daybo Logic nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/

/* Header for input source linked list */
#ifndef INC_RTTB_INPUTLL_H
#define INC_RTTB_INPUTLL_H
/*--------------------------------------------------------------------------*/
typedef struct _S_SOURCE /* A source file entry during processing (LL) */
{
  char* FileName; /* Pointer to filename, never altered bu will be freed if FileNameDynamic is TRUE */
  ULONG Length; /* Length of the file in bytes (64-bit on Alpha) */
  BOOL FileNameDynamic; /* TRUE if FileName should be released, else it probally points to the command line */
  void* PNext; /* Next structure like this (or NULL) */
} S_SOURCE;

#ifdef __cplusplus
 extern "C" {
#endif
BOOL LL_AddSource(S_SOURCE* NewSourceFile); /* Adds a source file to the linked list, PNext is ignored */
BOOL LL_DeleteSources(void); /* Deletes all sources */
unsigned int LL_CountItems(void); /* Returns the number of items in the LL, not it's cached, the list is not crawled */
S_SOURCE* LL_Address(void); /* Get address of base node */
#ifdef __cplusplus
 }
#endif
/*--------------------------------------------------------------------------*/
#endif /*!INC_RTTB_INPUTLL_H*/
