/*
Daybo Logic Run-Time TarBall Library And Tools
Copyright (c) 2000-2006, David Duncan Ross Palmer, Daybo Logic
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
      
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
      
    * Neither the name of the Daybo Logic nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef INC_RTTBUTIL_H
#define INC_RTTBUTIL_H

#ifdef __cplusplus
extern "C" {
#endif

/* Not all of these functional actually exist and won't be linked! */
/*-------------------------------------------------------------------------*/
/* Calculate a block's 16-bit checksum */
WORD rttbutil_CalcChk16(const void* RawData, const size_t SizeOfData);
/* Calculate a block's 32-bit checksum */
DWORD rttbutil_CalcChk32(const void* RawData, const size_t SizeOfData);
/* Sorry there is no 64-bit function supported yet, if you need it I'll add it */
/*DWORD dlutils_CalcChk64(const void* RawData, const size_t SizeOfData, DWORD* PHiDW);*/
/*-------------------------------------------------------------------------*/
WORD rttbutil_RevWORD(const WORD W); /* Reverses BYTEs in a WORD */
DWORD rttbutil_RevDWORD(const DWORD DW); /* Reverses WORDs in a DWORD and BYTEs in those WORDs */
/*-------------------------------------------------------------------------*/
int rttbutil_stricmp(const char* s1, const char* s2); /* Case insensitive compare, use this not stricmp()! */
/*-------------------------------------------------------------------------*/
char* rttbutil_strupr(char* s); /* Converts a string to uppercase just like non-ANSI strupr() */
char* rttbutil_strlwr(char* s); /* Converts a string to lowercase just like ANSI 1995 strlwr() */
/*-------------------------------------------------------------------------*/
typedef struct _FILE_BLOCK_SIZE
{
  unsigned long BufferSize;
  unsigned long Loops;
  unsigned long Remainder;
} FILE_BLOCK_SIZE;
int rttbutil_CalcFileBlockSize(unsigned long FileLength, FILE_BLOCK_SIZE* CallerFileBlockSizePtr, const size_t BufferSize);
/*-------------------------------------------------------------------------*/
DWORD rttbutil_CalcFileChecksum32(FILE* HFile);
/*-------------------------------------------------------------------------*/
int rttbutil_GetFileLength(FILE* HFile, unsigned long* PLength);
/*-------------------------------------------------------------------------*/
char* rttbutil_RTrimWithLen(char* str, size_t len);
#define rttbutil_RTrim(s) rttbutil_RTrimWithLen((s), strlen((s)))
/*-------------------------------------------------------------------------*/
#ifdef __cplusplus
}
#endif


#endif /*!INC_RTTBUTIL_H*/
